> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.astropods.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.astropods.com/_mcp/server.

# Replace an observer's triggers

PUT https://astropods.com/api/v1/accounts/{account}/rooms/{room_id}/observers/{observer_id}/triggers
Content-Type: application/json

Reference: https://docs.astropods.com/api-reference/astropods-api/rooms/replace-an-observers-triggers

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `account` (string, required) — Account name
- `room_id` (string, required) — Room ID
- `observer_id` (string, required) — Observer ID

### Body (application/json)

This endpoint expects a RoomObserverTriggersRequest.

- `triggers` (list of Trigger, optional)

## Response

### 200

OK

- `created_at` (datetime, optional)
- `created_by_user_id` (string, optional)
- `display_name` (string, optional)
- `enabled` (boolean, optional)
- `id` (string, optional)
- `kind` (string, optional)
- `last_event_at` (datetime, optional, nullable)
- `name` (string, optional)
- `repo` (string, optional)
- `slack` (RoomObserverSlackResponse, optional)
- `stopped_at` (datetime, optional, nullable)
- `stopped_reason` (string, optional)
- `triggers` (list of Trigger, optional)
- `url` (string, optional)
- `webhook_url` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `code` (string, optional)
- `details` (string, optional)
- `error` (string, optional)

### 403 Forbidden Error

Forbidden

- `code` (string, optional)
- `details` (string, optional)
- `error` (string, optional)

### 404 Not Found Error

Not Found

- `code` (string, optional)
- `details` (string, optional)
- `error` (string, optional)

### 422 Unprocessable Entity Error

Unprocessable Entity

- `code` (string, optional)
- `details` (string, optional)
- `error` (string, optional)

## Types

### Trigger

- `actions` (list of string, optional)
- `event` (string, optional)
- `exclude` (TriggerExclusions, optional)
- `filters` (TriggerFilters, optional)
- `job` (string, optional)

### RoomObserverSlackResponse

- `channel_id` (string, optional)
- `channel_name` (string, optional)
- `team_id` (string, optional)

### TriggerExclusions

- `authors` (list of string, optional)
- `branches` (list of string, optional)
- `contains` (string, optional)
- `emoji` (list of string, optional)
- `labels` (list of string, optional)
- `workflows` (list of string, optional)

### TriggerFilters

- `authors` (list of string, optional)
- `branches` (list of string, optional)
- `conclusions` (list of string, optional)
- `contains` (string, optional)
- `drafts` (boolean, optional)
- `emoji` (list of string, optional)
- `labels` (list of string, optional)
- `on` (list of string, optional)
- `prereleases` (boolean, optional)
- `states` (list of string, optional)
- `workflows` (list of string, optional)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "created_at": "2024-01-15T09:30:00Z",
  "created_by_user_id": "string",
  "display_name": "string",
  "enabled": true,
  "id": "string",
  "kind": "string",
  "last_event_at": "2024-01-15T09:30:00Z",
  "name": "string",
  "repo": "string",
  "slack": {
    "channel_id": "string",
    "channel_name": "string",
    "team_id": "string"
  },
  "stopped_at": "2024-01-15T09:30:00Z",
  "stopped_reason": "string",
  "triggers": [
    {
      "actions": [
        "string"
      ],
      "event": "string",
      "exclude": {
        "authors": [
          "string"
        ],
        "branches": [
          "string"
        ],
        "contains": "string",
        "emoji": [
          "string"
        ],
        "labels": [
          "string"
        ],
        "workflows": [
          "string"
        ]
      },
      "filters": {
        "authors": [
          "string"
        ],
        "branches": [
          "string"
        ],
        "conclusions": [
          "string"
        ],
        "contains": "string",
        "drafts": true,
        "emoji": [
          "string"
        ],
        "labels": [
          "string"
        ],
        "on": [
          "string"
        ],
        "prereleases": true,
        "states": [
          "string"
        ],
        "workflows": [
          "string"
        ]
      },
      "job": "string"
    }
  ],
  "url": "string",
  "webhook_url": "string"
}
```

**SDK Code**

```python
import requests

url = "https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://astropods.com/api/v1/accounts/account/rooms/room_id/observers/observer_id/triggers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```